#!/bin/bash

is_mass_storage_enabled() {
	local LINK="$GADGET_DIR/configs/c.1/mass_storage.usb0"
	if [ -L "$LINK" ]; then
		return 0
	fi
	return 1
}

mass_storage_enable() {
	local flag=0
	# remove (disable) existing function link if present
	if [[ -e "$GADGET_DIR/configs/c.1/mass_storage.usb0" ]]; then
		rm -rf "$GADGET_DIR/configs/c.1/mass_storage.usb0"
	fi

	# create mass_storage function directory and set params
	mkdir -p "$GADGET_DIR/functions/mass_storage.usb0" || {
		echo "USB Gadgets directory is not properly configured!"
		return 1
	}

	# clear /mass_storage/lun.0/file before configuring
	echo >"$GADGET_DIR/functions/mass_storage.usb0/lun.0/file"

	# add file/block for storage
	if [[ -n $MASS_STORAGE_REMOVABLE ]]; then
		echo "$MASS_STORAGE_REMOVABLE" >"$GADGET_DIR/functions/mass_storage.usb0/lun.0/removable" 2>/dev/null || {
			flag=1
			echo "Invalid removable value: $MASS_STORAGE_REMOVABLE" >&2
		}
	fi

	if [[ -n $MASS_STORAGE_RO ]]; then
		echo "$MASS_STORAGE_RO" >"$GADGET_DIR/functions/mass_storage.usb0/lun.0/ro" 2>/dev/null || {
			flag=1
			echo "Invalid ro value: $MASS_STORAGE_RO"
		}
	fi

	if [[ -n $MASS_STORAGE_CDROM ]]; then
		echo "$MASS_STORAGE_CDROM" >"$GADGET_DIR/functions/mass_storage.usb0/lun.0/cdrom" 2>/dev/null || {
			flag=1
			echo "Invalid FILE path: $MASS_STORAGE_CDROM" >&2
		}
	fi

	if [[ -n $MASS_STORAGE_FILE ]]; then
		echo "$MASS_STORAGE_FILE" >"$GADGET_DIR/functions/mass_storage.usb0/lun.0/file" 2>/dev/null || {
			flag=1
			echo "Invalid FILE path: $MASS_STORAGE_FILE" >&2
		}
	fi

	if [[ $flag -eq 1 ]]; then
		return 1
	fi

	# link to configs/c.1
	ln -s "$GADGET_DIR/functions/mass_storage.usb0" "$GADGET_DIR/configs/c.1"
}

mass_storage_disable() {
	if [ ! -s "$GADGET_DIR/UDC" ]; then
		echo >"$GADGET_DIR/UDC"
	fi

	# remove mass_storage.usb0 link from configs/c.1
	rm -rf "$GADGET_DIR/configs/c.1/mass_storage.usb0"
}
