# shellcheck shell=bash
C_SRATE=96000
P_SRATE=96000
C_CHMASK=0x03
P_CHMASK=0x03
C_SSIZE=0x02
P_SSIZE=0x02

dialog_enable_audio() {
	# Display menu with additional options for UAC2.0 USB audio gadget
	selected=$(
		__dialog_menu "USB Audio Gadget Configuration:" \
			--cancel-button "Save" \
			"<-- Return to main menu" "" \
			"Capture sampling rate (c_srate): " "   $C_SRATE -->" \
			"Playback sampling rate (p_srate): " "   $P_SRATE -->" \
			"Capture channel mask (c_chmask): " "   $C_CHMASK -->" \
			"Playback channel mask (p_chmask): " "   $P_CHMASK -->" \
			"Capture sampling size (c_ssize): " "   $C_SSIZE -->" \
			"Playback sampling size (p_ssize): " "   $P_SSIZE -->"
	)

	case $selected in
	*c_srate*)
		ret=$(__dialog_inputbox "Enter Capture Sampling Rate (c_srate): " "$C_SRATE")
		if [[ $? -eq 0 ]]; then
			C_SRATE=$ret
		fi
		dialog_enable_audio
		;;
	*p_srate*)
		ret=$(__dialog_inputbox "Enter Playback Sampling Rate (p_srate): " "$P_SRATE")
		if [[ $? -eq 0 ]]; then
			P_SRATE=$ret
		fi
		dialog_enable_audio
		;;
	*c_chmask*)
		ret=$(__dialog_inputbox "Enter Capture Channel Mask (c_chmask): " "$C_CHMASK")
		if [[ $? -eq 0 ]]; then
			C_CHMASK=$ret
		fi
		dialog_enable_audio
		;;
	*p_chmask*)
		ret=$(__dialog_inputbox "Enter Playback Channel Mask (p_chmask): " "$P_CHMASK")
		if [[ $? -eq 0 ]]; then
			dialog_enable_audio
		fi
		dialog_enable_audio
		;;
	*c_ssize*)
		ret=$(__dialog_inputbox "Enter Capture Sampling Size (c_ssize): " "$C_SSIZE")
		if [[ $? -eq 0 ]]; then
			C_SSIZE=$ret
		fi
		dialog_enable_audio
		;;
	*p_ssize*)
		ret=$(__dialog_inputbox "Enter Playback Sampling Size (p_ssize): " "$P_SSIZE")
		if [[ $? -eq 0 ]]; then
			P_SSIZE=$ret
		fi
		dialog_enable_audio
		;;
	*)
		__dialog_yesno "Do you want to apply these configurations?"
		if [[ $? -eq 0 ]]; then
			local retmsg
			# Applying configurations
			retmsg=$(configfs_add_audio)
			if [[ $? -eq 1 ]]; then
				__dialog_msgbox "$retmsg \n\n> Please reconfigure!"
			else
				__dialog_msgbox "USB Audio Gadget configured successfully."
			fi
		else
			__dialog_msgbox "Action cancelled. Changes were not applied."
		fi
		;;
	esac
}

dialog_disable_audio() {
	__dialog_yesno "Do you really intend to disable/reconfigure USB Audio Gadget? \nCAUTION: This action will immediately reboot the system!"
	if [[ $? == 0 ]]; then
		configfs_disable_audio
		#if [[ -z $? ]]; then
		#    __dialog_msgbox "USB Audio Gadget disabled! Rebooting system....."
		#    #__dialog_msgbox "Kitty will now reboot the system"
		#fi
		reboot
	fi
	#__dialog_msgbox "Kitty will ignore you ):"
}

dialog_audio() {
	is_enable_audio
	if [[ $? == 0 ]]; then
		dialog_disable_audio
	else
		dialog_enable_audio
	fi
}
